import React from 'react';
import cx from 'classnames';
import Icon from './Icon';
import LazyIcon from './LazyIcon';
var BASE_CLASS = 'sui-AtomIcon';
export var ATOM_ICON_COLORS = {
  accent: 'accent',
  alert: 'alert',
  currentColor: 'currentColor',
  error: 'error',
  primary: 'primary',
  success: 'success',
  gray: 'gray'
};
export var ATOM_ICON_SIZES = {
  extraSmall: 'extraSmall',
  small: 'small',
  medium: 'medium',
  large: 'large',
  extraLarge: 'extraLarge'
};
export var ATOM_ICON_RENDERS = {
  eager: 'eager',
  lazy: 'lazy'
};
export default function AtomIcon(_ref) {
  var children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? ATOM_ICON_COLORS.currentColor : _ref$color,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? ATOM_ICON_SIZES.small : _ref$size,
      _ref$render = _ref.render,
      render = _ref$render === void 0 ? ATOM_ICON_RENDERS.eager : _ref$render;
  var className = cx(BASE_CLASS, BASE_CLASS + "--" + size, color && BASE_CLASS + "--" + color);
  var IconRender = render === ATOM_ICON_RENDERS.eager ? Icon : LazyIcon;
  return /*#__PURE__*/React.createElement(IconRender, {
    className: className
  }, children);
}
AtomIcon.displayName = 'AtomIcon';